#include "fxlib.h"
#include "MonochromeLib.h"
#include "serial.h"


void affiche(int x, int y, const unsigned char *str)
{
	locate(x,y);
	Print((unsigned char*)str);
}

char start()
{
    unsigned int key = 0;
	affiche(2,1,"Tu veux commencer ?");
	affiche(1,4,"1 - Oui");
	affiche(1,6,"2 - Non");
	
	while((key!=KEY_CHAR_1) & (key!=KEY_CHAR_2)) {
			GetKey(&key);
	}
	
	if(key==KEY_CHAR_1) return 1;
	if(key==KEY_CHAR_2) return 2;
}

char verifierVerif(const char verif[])
{
	if( (verif[0]==verif[1]) && (verif[1]==verif[2]) && (verif[0]!=0) ) return verif[0];
	if( (verif[3]==verif[4]) && (verif[4]==verif[5]) && (verif[3]!=0) ) return verif[3];
	if( (verif[6]==verif[7]) && (verif[7]==verif[8]) && (verif[6]!=0) ) return verif[6];
	if( (verif[0]==verif[3]) && (verif[3]==verif[6]) && (verif[0]!=0) ) return verif[0];
	if( (verif[1]==verif[4]) && (verif[4]==verif[7]) && (verif[1]!=0) ) return verif[1];
	if( (verif[2]==verif[5]) && (verif[5]==verif[8]) && (verif[2]!=0) ) return verif[2];
	if( (verif[0]==verif[4]) && (verif[4]==verif[8]) && (verif[0]!=0) ) return verif[0];
	if( (verif[2]==verif[4]) && (verif[4]==verif[6]) && (verif[2]!=0) ) return verif[2];
	return 0;
}

void TraitDeFin(const char verif[])
{
	if( (verif[0]==verif[1]) && (verif[1]==verif[2]) && (verif[0]!=0) ) ML_line(13,62,13,2,ML_BLACK);
	if( (verif[3]==verif[4]) && (verif[4]==verif[5]) && (verif[3]!=0) ) ML_line(33,62,33,2,ML_BLACK);
	if( (verif[6]==verif[7]) && (verif[7]==verif[8]) && (verif[6]!=0) ) ML_line(53,62,53,2,ML_BLACK);
	if( (verif[0]==verif[3]) && (verif[3]==verif[6]) && (verif[0]!=0) ) ML_line(3,52,63,52,ML_BLACK);
	if( (verif[1]==verif[4]) && (verif[4]==verif[7]) && (verif[1]!=0) ) ML_line(3,32,63,32,ML_BLACK);
	if( (verif[2]==verif[5]) && (verif[5]==verif[8]) && (verif[2]!=0) ) ML_line(3,12,63,12,ML_BLACK);
	if( (verif[0]==verif[4]) && (verif[4]==verif[8]) && (verif[0]!=0) ) ML_line(3,62,63,2,ML_BLACK);
	if( (verif[2]==verif[4]) && (verif[4]==verif[6]) && (verif[2]!=0) ) ML_line(3,2,64,63,ML_BLACK);
	ML_display_vram();
}

void grille()
{
	ML_clear_vram();
	ML_line(3,1,3,64,ML_BLACK);
	ML_line(23,1,23,64,ML_BLACK);
	ML_line(43,1,43,64,ML_BLACK);
	ML_line(63,1,63,64,ML_BLACK);
	ML_line(2,2,65,2,ML_BLACK);
	ML_line(2,22,65,22,ML_BLACK);
	ML_line(2,42,65,42,ML_BLACK);	
	ML_line(2,62,65,62,ML_BLACK);
	ML_display_vram();
}

void signe(char x,char y,char nb)
{
	if((nb%2)!=0) ML_circle(x,y,9,ML_BLACK);
	else {
		ML_line(x-9,y-9,x+10,y+10,ML_BLACK);
		ML_line(x-9,y+9,x+10,y-10,ML_BLACK);
	}	
}


int AddIn_main(int isAppli, unsigned short OptionNum)
{	
	unsigned int key;
	unsigned char config[] = {0, 5, 0, 0, 0, 0};
	unsigned int erreur;
	char x=0,y=0,nb=0,test,etat=0;
	char verif[9] = {0};
	char mode = start();
	erreur = Serial_Open(config);

	if(erreur==0 || erreur == 3)
	{
		grille();
		
		do
		{
			key=0;
			x=0;
			y=0;
			
			if(mode==1)
			{
				test=1;
				affiche(12,1,"A toi !    ");
				do
				{
					key=0;
					while((key!=KEY_CHAR_1) && (key!=KEY_CHAR_2) && (key!=KEY_CHAR_3) && (key!=KEY_CHAR_4) && (key!=KEY_CHAR_5) && (key!=KEY_CHAR_6) && (key!=KEY_CHAR_7) && (key!=KEY_CHAR_8) && (key!=KEY_CHAR_9))
					{
						GetKey(&key);
					}
				
					if((key==KEY_CHAR_1) && (verif[0]==0)) test=0;
					if((key==KEY_CHAR_2) && (verif[3]==0)) test=0;
					if((key==KEY_CHAR_3) && (verif[6]==0)) test=0;
					if((key==KEY_CHAR_4) && (verif[1]==0)) test=0;
					if((key==KEY_CHAR_5) && (verif[4]==0)) test=0;
					if((key==KEY_CHAR_6) && (verif[7]==0)) test=0;
					if((key==KEY_CHAR_7) && (verif[2]==0)) test=0;
					if((key==KEY_CHAR_8) && (verif[5]==0)) test=0;
					if((key==KEY_CHAR_9) && (verif[8]==0)) test=0;
					
				}while(test);
				
				if((key==KEY_CHAR_1) || (key==KEY_CHAR_2) || (key==KEY_CHAR_3)) y=52;
				if((key==KEY_CHAR_4) || (key==KEY_CHAR_5) || (key==KEY_CHAR_6)) y=32;
				if((key==KEY_CHAR_7) || (key==KEY_CHAR_8) || (key==KEY_CHAR_9)) y=12;
				if((key==KEY_CHAR_1) || (key==KEY_CHAR_4) || (key==KEY_CHAR_7)) x=13;
				if((key==KEY_CHAR_2) || (key==KEY_CHAR_5) || (key==KEY_CHAR_8)) x=33;
				if((key==KEY_CHAR_3) || (key==KEY_CHAR_6) || (key==KEY_CHAR_9)) x=53;

				Serial_WriteByte(x);
				Sleep(20);
				Serial_WriteByte(y);
			}

		
			if(mode==2)
			{
				affiche(12,1,"A l'autre !");
				ML_display_vram();
				while(x==0) {
					Serial_ReadByte(&x);
					Sleep(10);
				}

				Sleep(40);
				Serial_ReadByte(&y);
			}
			
			if(x==13) {
				if(y==52) verif[0]=((nb%2)+1);
				if(y==32) verif[1]=((nb%2)+1);
				if(y==12) verif[2]=((nb%2)+1);
			}
			else if(x==33) {
				if(y==52) verif[3]=((nb%2)+1);
				if(y==32) verif[4]=((nb%2)+1);
				if(y==12) verif[5]=((nb%2)+1);
			}
			else {
				if(y==52) verif[6]=((nb%2)+1);
				if(y==32) verif[7]=((nb%2)+1);
				if(y==12) verif[8]=((nb%2)+1);
			}
				
			signe(x,y,nb);
			ML_display_vram();
			nb++;
			mode++;
			if(mode==3) mode=1;
			
			etat = verifierVerif(verif);
			if(etat!=0) break;
		
		}while(nb<9);

		if(etat!=0) {
			if(mode==2) affiche(12,3,"Gagn\xE6\x0A"" !");
			else if(mode==1) affiche(12,3,"Perdu !");
		}
		TraitDeFin(verif);
		
		affiche(12,1,"Game Over");
		ML_display_vram();
		
		Serial_Close(0);
		while(1){
			GetKey(&key);
		}
	}
	return 1;
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section
